import 'package:flutter/material.dart';
import 'package:vivanta_connect_example/select_apple_health_activity_type.dart';
import 'package:vivanta_connect_example/select_apple_health_parameter_type.dart';
import 'package:vivanta_connect_example/select_google_health_activity_type.dart';
import 'package:vivanta_connect_example/select_google_health_parameter_type.dart';
import 'package:vivanta_connect_flutter/services/apple_health.dart';
import 'package:vivanta_connect_flutter/services/google_health_connect.dart';

Future<void> writeAppleHealthParameter(BuildContext context) async {
  final parameterSelection =
      await Navigator.of(context).push<AppleHealthParameterSelection>(
    MaterialPageRoute(
      builder: (context) => const SelectAppleHealthParameterType(),
    ),
  );

  if (parameterSelection != null) {
    final appleHealth = AppleHealth();
    final endDate = DateTime.now();
    final startDate = endDate.subtract(const Duration(seconds: 1));
    final _ = await appleHealth.writeParameter(
      parameterType: parameterSelection.parameterType,
      start: startDate,
      end: endDate,
      value: parameterSelection.value,
    );
  }
}

Future<void> writeAppleHealthActivity(BuildContext context) async {
  final activitySelection =
      await Navigator.of(context).push<AppleHealthActivitySelection>(
    MaterialPageRoute(
      builder: (context) => const SelectAppleHealthActivityType(),
    ),
  );

  if (activitySelection != null) {
    final appleHealth = AppleHealth();
    final startDate = DateTime.now();
    final _ = await appleHealth.writeActivity(
      activityType: activitySelection.activityType,
      start: startDate,
      end: startDate.add(Duration(seconds: activitySelection.duration)),
      calories: activitySelection.calories,
      distance: activitySelection.distance,
    );
  }
}

Future<void> writeGoogleHealthParameter(BuildContext context) async {
  final parameterSelection =
      await Navigator.of(context).push<GoogleHealthParameterSelection>(
    MaterialPageRoute(
      builder: (context) => const SelectGoogleHealthParameterType(),
    ),
  );

  if (parameterSelection != null) {
    final googleHealth = GoogleHealthConnect();
    final endDate = DateTime.now();
    final startDate = endDate.subtract(const Duration(seconds: 1));
    final _ = await googleHealth.writeParameter(
      parameterType: parameterSelection.parameterType,
      start: startDate,
      end: endDate,
      value: parameterSelection.value,
    );
  }
}

Future<void> writeGoogleHealthActivity(BuildContext context) async {
  final activitySelection =
      await Navigator.of(context).push<GoogleHealthActivitySelection>(
    MaterialPageRoute(
      builder: (context) => const SelectGoogleHealthActivityType(),
    ),
  );

  if (activitySelection != null) {
    final googleHealth = GoogleHealthConnect();
    final startDate = DateTime.now();
    final _ = await googleHealth.writeActivity(
      activityType: activitySelection.activityType,
      start: startDate,
      end: startDate.add(Duration(seconds: activitySelection.duration)),
      calories: activitySelection.calories,
      distance: activitySelection.distance,
    );
  }
}
