import 'package:json_annotation/json_annotation.dart';

import 'package:vivanta_connect_flutter/data/apple_category_type_client.dart';
import 'package:vivanta_connect_flutter/data/apple_quantity_type_client.dart';
import 'package:vivanta_connect_flutter/data/google_parameter_type_client.dart';

part 'client.g.dart';

@JsonSerializable()
class Client {
  final int? id;
  final String? externalId;
  final String? name;
  final String? returnToLink;
  final String? type;
  final List<AppleQuantityTypeClient>? appleQuantityTypeClient;
  final List<AppleCategoryTypeClient>? appleCategoryTypeClient;
  final List<GoogleParameterTypeClient>? googleParameterTypeClient;

  Client({
    this.id,
    this.externalId,
    this.name,
    this.returnToLink,
    this.type,
    this.appleQuantityTypeClient,
    this.appleCategoryTypeClient,
    this.googleParameterTypeClient,
  });

  factory Client.fromJson(Map<String, dynamic> json) => _$ClientFromJson(json);

  Map<String, dynamic> toJson() => _$ClientToJson(this);
}
