import 'package:json_annotation/json_annotation.dart';

import 'package:vivanta_connect_flutter/data/client.dart';
import 'package:vivanta_connect_flutter/data/credential.dart';

part 'user.g.dart';

@JsonSerializable()
class User {
  final int? id;
  final String? externalId;
  final Client? client;
  final String? token;
  final List<Credential>? credentials;

  User({
    this.id,
    this.externalId,
    this.client,
    this.token,
    this.credentials,
  });

  factory User.fromJson(Map<String, dynamic> json) => _$UserFromJson(json);

  Map<String, dynamic> toJson() => _$UserToJson(this);
}
