import 'package:flutter/material.dart';

import 'package:vivanta_connect_flutter/data/brand.dart';
import 'package:vivanta_connect_flutter/styles/fonts.dart';

class BrandItem extends StatelessWidget {
  final Brand brand;
  final void Function(Brand brand)? onTap;

  const BrandItem({
    Key? key,
    required this.brand,
    this.onTap,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    final size = MediaQuery.of(context).size.width / 2;
    return Padding(
      padding: const EdgeInsets.all(24),
      child: GestureDetector(
        onTap: onTap == null ? null : () => onTap!(brand),
        child: Column(
          mainAxisAlignment: MainAxisAlignment.start,
          children: [
            SizedBox(
              height: size - 80,
              child: Image.network(
                brand.image ?? '',
                fit: BoxFit.cover,
              ),
            ),
            SizedBox(
              height: 32,
              child: Text(
                brand.name ?? '',
                style: VivantaFonts.main,
                textAlign: TextAlign.center,
                overflow: TextOverflow.ellipsis,
                maxLines: 2,
              ),
            ),
          ],
        ),
      ),
    );
  }
}
